Ractor.make_shareable is broken in code loaded with

RubyVM::InstructionSequence.load_from_binary
Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.0.2p107, ruby 3.1.0dev Backport: 3.0: DONE

Description

This was first reported as a Bootsnap bug: https://github.com/Shopify/bootsnap/issues/376

But I reduced it to:

source = <<~RUBY

  x = :foo

  pr = Proc.new { p x }

  Ractor.make_shareable(pr)

  pr.call

RUBY

RubyVM::InstructionSequence.compile(source).eval # :foo

RubyVM::InstructionSequence.load_from_binary(RubyVM::InstructionSequence.compile(source).to_binary

).eval # false

 The bug is present on both 3.0.2 and 3.1.0-dev. I have no idea what might cause this.

Related issues:

Related to Ruby - Bug #18243: Ractor.make_shareable does not freeze the recei... Closed

Associated revisions

Revision 217df51f0e5d9824ed712a4d175f555d932e44d8 - 10/07/2021 10:39 PM - tenderlovemaking (Aaron Patterson)

Dump outer variables tables when dumping an iseq to binary

This commit dumps the outer variables table when dumping an iseq to

binary.  This fixes a case where Ractors aren't able to tell what outer

variables belong to a lambda after the lambda is loaded via ISeq.load_from_binary

[Bug #18232] [ruby-core:105504]

Revision 217df51f0e5d9824ed712a4d175f555d932e44d8 - 10/07/2021 10:39 PM - tenderlovemaking (Aaron Patterson)

Dump outer variables tables when dumping an iseq to binary

This commit dumps the outer variables table when dumping an iseq to

binary.  This fixes a case where Ractors aren't able to tell what outer

variables belong to a lambda after the lambda is loaded via ISeq.load_from_binary

[Bug #18232] [ruby-core:105504]

Revision 217df51f - 10/07/2021 10:39 PM - tenderlovemaking (Aaron Patterson)

Dump outer variables tables when dumping an iseq to binary

This commit dumps the outer variables table when dumping an iseq to

binary.  This fixes a case where Ractors aren't able to tell what outer

variables belong to a lambda after the lambda is loaded via ISeq.load_from_binary

[Bug #18232] [ruby-core:105504]

Revision a2fe4b75e4b236ad15778c59ace63006ace53889 - 10/16/2021 04:26 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 217df51f0e5d9824ed712a4d175f555d932e44d8: [Backport #18232]

    Dump outer variables tables when dumping an iseq to binary
https://github.com/Shopify/bootsnap/issues/376


    This commit dumps the outer variables table when dumping an iseq to

    binary.  This fixes a case where Ractors aren't able to tell what outer

    variables belong to a lambda after the lambda is loaded via ISeq.load_from_binary

    [Bug #18232] [ruby-core:105504]

    ---

     compile.c              | 55 +++++++++++++++++++++++++++++++++++++++++++++++++-

     test/ruby/test_iseq.rb | 10 +++++++++

     2 files changed, 64 insertions(+), 1 deletion(-)

Revision a2fe4b75e4b236ad15778c59ace63006ace53889 - 10/16/2021 04:26 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 217df51f0e5d9824ed712a4d175f555d932e44d8: [Backport #18232]

    Dump outer variables tables when dumping an iseq to binary

    This commit dumps the outer variables table when dumping an iseq to

    binary.  This fixes a case where Ractors aren't able to tell what outer

    variables belong to a lambda after the lambda is loaded via ISeq.load_from_binary

    [Bug #18232] [ruby-core:105504]

    ---

     compile.c              | 55 +++++++++++++++++++++++++++++++++++++++++++++++++-

     test/ruby/test_iseq.rb | 10 +++++++++

     2 files changed, 64 insertions(+), 1 deletion(-)

Revision a2fe4b75 - 10/16/2021 04:26 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 217df51f0e5d9824ed712a4d175f555d932e44d8: [Backport #18232]

    Dump outer variables tables when dumping an iseq to binary

    This commit dumps the outer variables table when dumping an iseq to

    binary.  This fixes a case where Ractors aren't able to tell what outer

    variables belong to a lambda after the lambda is loaded via ISeq.load_from_binary

    [Bug #18232] [ruby-core:105504]

    ---

     compile.c              | 55 +++++++++++++++++++++++++++++++++++++++++++++++++-

     test/ruby/test_iseq.rb | 10 +++++++++

     2 files changed, 64 insertions(+), 1 deletion(-)

History

#1 - 10/06/2021 09:22 AM - byroot (Jean Boussier)

Because OpenStruct was recently changed to use make_shareable, this bug suddenly became much more problematic. We actually hit it in

production.

#2 - 10/06/2021 06:31 PM - Eregon (Benoit Daloze)

FYI the way it currently works for OpenStruct seems buggy on the Ractor side: #18243

#3 - 10/06/2021 06:31 PM - Eregon (Benoit Daloze)

- Related to Bug #18243: Ractor.make_shareable does not freeze the receiver of a Proc but allows accessing ivars of it added

#4 - 10/06/2021 06:38 PM - Eregon (Benoit Daloze)

(this comment was moved to https://bugs.ruby-lang.org/issues/18243, replied to the wrong issue)

#5 - 10/06/2021 06:47 PM - tenderlovemaking (Aaron Patterson)

It looks like the outer variables list is being lost when we dump the iseq to binary.  AFAICT, that list is only created at compile time.  I'll try to make a

patch that reconstructs the list on iseq load as well.

#6 - 10/06/2021 09:03 PM - tenderlovemaking (Aaron Patterson)

- File 0001-Dump-outer-variables-tables-when-dumping-an-iseq-to-.patch added

I've attached a patch that fixes this (for me) along with a test.  I had to change the information that we dump when dumping an ISeq, so maybe we

need to change the binary format version number or something?  I'm not sure.  Anyway there is also a PR here

#7 - 10/07/2021 10:40 PM - tenderlovemaking (Aaron Patterson)
https://github.com/ruby/ostruct/pull/29
https://redmine.ruby-lang.org/issues/18243
https://bugs.ruby-lang.org/issues/18243
https://github.com/ruby/ruby/blob/e4d85d3a2d0c7d4a1abf981fb1ba557e21cad968/vm.c#L1124
https://github.com/ruby/ruby/pull/4942


- Status changed from Open to Closed

Applied in changeset git|217df51f0e5d9824ed712a4d175f555d932e44d8.

Dump outer variables tables when dumping an iseq to binary

This commit dumps the outer variables table when dumping an iseq to

binary.  This fixes a case where Ractors aren't able to tell what outer

variables belong to a lambda after the lambda is loaded via ISeq.load_from_binary

[Bug #18232] [ruby-core:105504]

#8 - 10/08/2021 07:13 AM - byroot (Jean Boussier)

- Backport changed from 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0: UNKNOWN to 3.0: REQUIRED

#9 - 10/16/2021 04:56 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.0: REQUIRED to 3.0: DONE

ruby_3_0 a2fe4b75e4b236ad15778c59ace63006ace53889 merged revision(s) 217df51f0e5d9824ed712a4d175f555d932e44d8.

Files

0001-Dump-outer-variables-tables-when-dumping-an-iseq-to-.patch 5.55 KB 10/06/2021 tenderlovemaking (Aaron Patterson)

Powered by TCPDF (www.tcpdf.org)

05/17/2025 3/3

https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/217df51f0e5d9824ed712a4d175f555d932e44d8
https://redmine.ruby-lang.org/issues/18232
bugs.ruby-lang.org/issues/18232
http://www.tcpdf.org

